package de.intevation.flys.artifacts.model;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.CallContext;

import de.intevation.artifactdatabase.state.DefaultFacet;
import de.intevation.artifactdatabase.state.Facet;

import de.intevation.flys.artifacts.states.DefaultState.ComputeType;

import de.intevation.flys.artifacts.WINFOArtifact;


import org.apache.log4j.Logger;

public class ReportFacet
extends      DefaultFacet
implements   FacetTypes
{
    private static Logger logger = Logger.getLogger(ReportFacet.class);

    protected ComputeType type;
    protected String      hash;
    protected String      stateId;

    public ReportFacet() {
        this(ComputeType.ADVANCE);
    }

    public ReportFacet(ComputeType type) {
        super(0, REPORT, "report");
        this.type = type;
    }


    public ReportFacet(ComputeType type, String hash, String stateId) {
        super(0, REPORT, "report");
        this.type    = type;
        this.hash    = hash;
        this.stateId = stateId;
    }

    public Object getData(Artifact artifact, CallContext context) {
        logger.debug("get report data");

        WINFOArtifact winfo = (WINFOArtifact)artifact;

        CalculationResult cr = (CalculationResult)winfo.compute(
            context, hash, stateId, type, false);

        return cr.getReport();
    }

    @Override
    public Facet deepCopy() {
        ReportFacet copy = new ReportFacet();
        copy.set(this);
        copy.type    = type;
        copy.hash    = hash;
        copy.stateId = stateId;
        return copy;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
